﻿
// ReimuModeLessDlg.cpp : 実装ファイル
//

#include "pch.h"
#include "framework.h"
#include "ReimuModeLess.h"
#include "ReimuModeLessDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// アプリケーションのバージョン情報に使われる CAboutDlg ダイアログ

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// ダイアログ データ
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV サポート

// 実装
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CReimuModeLessDlg ダイアログ



CReimuModeLessDlg::CReimuModeLessDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_REIMUMODELESS_DIALOG, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CReimuModeLessDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_MFCCOLORBUTTON_BKCOL, m_cBkColor);
	DDX_Control(pDX, IDC_SLIDER_TRANS, m_cSldTrans);
}

BEGIN_MESSAGE_MAP(CReimuModeLessDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_MFCCOLORBUTTON_BKCOL, &CReimuModeLessDlg::OnBnClickedMfccolorbuttonBkcol)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SLIDER_TRANS, &CReimuModeLessDlg::OnNMReleasedcaptureSliderTrans)
END_MESSAGE_MAP()


// CReimuModeLessDlg メッセージ ハンドラー

BOOL CReimuModeLessDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// "バージョン情報..." メニューをシステム メニューに追加します。

	// IDM_ABOUTBOX は、システム コマンドの範囲内になければなりません。
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != nullptr)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// このダイアログのアイコンを設定します。アプリケーションのメイン ウィンドウがダイアログでない場合、
	//  Framework は、この設定を自動的に行います。
	SetIcon(m_hIcon, TRUE);			// 大きいアイコンの設定
	SetIcon(m_hIcon, FALSE);		// 小さいアイコンの設定

	// TODO: 初期化をここに追加します。

	// ターゲットウィンドウを作成する
	this->m_cRgnDlg.Create(IDD_DIALOG_RGN, this);
	{
		CRect r;
		this->m_cRgnDlg.GetClientRect(&r);
		{// リージョンを設定する
			// ターゲットウインドウのサイズに合わせてリージョンを設定する
			CRgn rgn;
			rgn.CreateEllipticRgn(r.left, r.top, r.right, r.bottom);
			this->m_cRgnDlg.SetWindowRgn(rgn, FALSE);
		}

		{// ターゲットウインドウをスクリーンの中央に初期表示する
			//　スクリーンの大きさを取得する
			int width = GetSystemMetrics(SM_CXSCREEN);// 幅
			int hight = GetSystemMetrics(SM_CYSCREEN);// 高さ
			int x = (width - r.Width()) / 2;
			int y = (hight - r.Height()) / 2;

			this->m_cRgnDlg.MoveWindow(x, y, r.Width(), r.Height(), FALSE);
		}
	}
	// スライダーの初期処理
	this->m_cSldTrans.SetRange(0, 255);
	this->m_cSldTrans.SetPos(180);

	// 半透明の処理
	this->m_cRgnDlg.ModifyStyleEx(0, WS_EX_LAYERED);
	this->m_cRgnDlg.SetLayeredWindowAttributes(0, this->m_cSldTrans.GetPos(), LWA_ALPHA);
	//カラーボタンの初期化
	this->m_cBkColor.SetColor(RGB(255, 0, 0));
	// 背景ブラシの初期化
	m_cRgnDlg.m_cBkBrush.CreateSolidBrush(this->m_cBkColor.GetColor());

	// ターゲットウインドウを表示する
	this->m_cRgnDlg.ShowWindow(SW_SHOW);
	return TRUE;  // フォーカスをコントロールに設定した場合を除き、TRUE を返します。
}

void CReimuModeLessDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// ダイアログに最小化ボタンを追加する場合、アイコンを描画するための
//  下のコードが必要です。ドキュメント/ビュー モデルを使う MFC アプリケーションの場合、
//  これは、Framework によって自動的に設定されます。

void CReimuModeLessDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 描画のデバイス コンテキスト

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// クライアントの四角形領域内の中央
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// アイコンの描画
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// ユーザーが最小化したウィンドウをドラッグしているときに表示するカーソルを取得するために、
//  システムがこの関数を呼び出します。
HCURSOR CReimuModeLessDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CReimuModeLessDlg::OnBnClickedMfccolorbuttonBkcol()
{
	// TODO: ここにコントロール通知ハンドラー コードを追加します。
	this->m_cRgnDlg.m_cBkBrush.DeleteObject();
	// ブラシを作り直す
	this->m_cRgnDlg.m_cBkBrush.CreateSolidBrush(this->m_cBkColor.GetColor());
	// ターゲットを再表示する
	this->m_cRgnDlg.Invalidate();
}


void CReimuModeLessDlg::OnNMReleasedcaptureSliderTrans(NMHDR* pNMHDR, LRESULT* pResult)
{
	// TODO: ここにコントロール通知ハンドラー コードを追加します。

	// スライダーの値で透明度を再設定する
	this->m_cRgnDlg.SetLayeredWindowAttributes(0, this->m_cSldTrans.GetPos(), LWA_ALPHA);

	*pResult = 0;
}
